function y=d_cycles(S,n)
% DCYCLES 	D_CYCLES(STR,N)
%		  	Displays the variable names of the elements of the N cycle 
%			in a structural matrix STR.
%			The list is sorted by ascending node eccentricity. 
%		 	STR is expected to have the 7 components generated by the
%			structure.m	function.
%
%			D_CYCLES(STR)
%			Lists the elements of ALL cycles in STR.

if ~isa(S,'struct') error('Input matrix is not a structure array.'); end;

if nargin==2
	if n<1|n>size(S.cyc,1) error('Cycle index exceeds cycles in structure.');
	else 
		report(S,n);
	end;
else
	for i=1:size(S.cyc,1)				% for each cycle partition
		report(S,i);
	end;
end;

function report(S,n)
	[E,N]=sort(S.ecc(n,:));				% sort nodes (N) and eccentricities (E)
	fprintf('Cycle %3.0f \n',n);
	fprintf('  Ecc Variable\n');
	for j=size(N,2)-nnz(E)+1:size(N,2)
		fprintf('  %3d ',full(E(j)));
		fprintf(S.nms(N(j),:));
		fprintf('\n');
	end;
	fprintf('\n');
