function y=d_levels(S,n)
% D_LEVELS 	D_LEVELS(STR,N)
%		  	Displays the variable names of the elements of the N level 
%			in a structural matrix STR.
%		 	STR is expected to have the 7 components generated by the
%			structure.m	function.
%
%			D_LEVELS(STR)
%			Lists the elements of ALL levels in STR.

if ~isa(S,'struct') error('Input matrix is not a structure array.'); end;

if nargin==2
	if n<1|n>size(S.lev,1) error('Variable index exceeds matrix dimensions.');
	else
		nodes = find(S.lev(n,:))';
		fprintf('Level %3.0f \n',n);
		for j=1:size(nodes,1)
			fprintf('     ');
			fprintf(S.nms(nodes(j),:));
			fprintf('\n');
		end;
		fprintf('\n');
	end;
else	
	for i=1:size(S.lev,1)				% for each level
		nodes = find(S.lev(i,:))';
		fprintf('Level %3.0f \n',i);
		for j=1:size(nodes,1)
			fprintf('     ');
			fprintf(S.nms(nodes(j),:));
			fprintf('\n');
		end;
		fprintf('\n');
	end;
end;
