function y=d_loops(S,p,n)
% D_LOOPS 	D_LOOPS(STR,P,N)
%		  	Displays the variable names of the elements of the N feedback 
%			loop in the P cycle partition of a structural matrix STR.
%		 	STR is expected to have the 7 components generated by the
%			structure.m	function.
%
%			D_LOOPS(STR,P)
%			Lists the elements of ALL feedback loops in partition P.
%
%			D_LOOPS(STR)
%			Lists the elements of ALL feedback loops in STR.

if ~isa(S,'struct') error('Input matrix is not a structure array.'); end;

if nargin==3
	if p<1|p>size(S.fbl,3) error('Cycle index exceeds cycles in structure.');
	else
		nl=size(nonzeros(S.fbl(:,1,p)),1);	% number of loops in partition -- loops are id by having the first col<>0
		if n<1|n>nl error('Loop index exceeds loops in cycle.');
		else
			fprintf('  Loop %3.0f \n',n);
			for j=1:size(S.fbl,2)
				if S.fbl(n,j)~=0
					fprintf('   ');
					fprintf(S.nms(S.fbl(n,j,p),:));
					fprintf('\n');
				else
					break;
				end;
			end;
			fprintf('\n');
		end;
	end;
elseif nargin==2
	if p<1|p>size(S.fbl,3) error('Cycle index exceeds cycles in structure.');
	else
		fprintf('Cycle %2.0f \n',p);
		nl=size(nonzeros(S.fbl(:,1,p)),1);	% number of loops in partition -- loops are id by having the first col<>0
		for i=1:nl	
			fprintf('  Loop %3.0f \n',i);
			for j=1:size(S.fbl,2)
				if S.fbl(i,j,p)~=0
					fprintf('    ');
					fprintf(S.nms(S.fbl(i,j,p),:));
					fprintf('\n');
				else
					break;
				end;
			end;
			fprintf('\n');
		end;
	end;
else
	for k=1:size(S.fbl,3)					% for each cycle partition
		fprintf('Cycle %2.0f \n',k);
		nl=size(nonzeros(S.fbl(:,1,k)),1);	% number of loops in partition -- loops are id by having the first col<>0
		for i=1:nl							% for each loop in partition
			fprintf('  Loop %3.0f \n',i);
			for j=1:size(S.fbl,2)
				if S.fbl(i,j,k)~=0
					fprintf('    ');
					fprintf(S.nms(S.fbl(i,j,k),:));
					fprintf('\n');
				else
					break;
				end;
			end;
			fprintf('\n');
		end;
	end;
end;
