function y=d_succ(s,nds)
% D_SUCC 	d_succ(ADJ,NODEs) 
%		 	Displays the successors of the nodes (NODEs) from adjacency 
%			matrix (ADJ). Equivalent to the "used in" relationship.
%			ADJ is expected to be the structured array containing the adjacency 
%			matrix (.adj) and the vector with variable names (.nms). 
%			ADJ can also be the full Structured matrix generated my the
%			structure.m function.
%			NODEs can be a single value or a list [x1 x2 x3].		
%
%			d_succ(ADJ)
%		 	Lists the successors for ALL nodes.

if ~isa(s,'struct') error('Input matrix is not a structure array.'); end;
	
if nargin==2
	for n=nds
		if n<1|n>size(s.adj,2) error('Variable index exceeds matrix dimensions.');
		else
			fprintf(s.nms(n,:));
			fprintf('\n');
			for j=1:size(s.adj,2)
				if (s.adj(n,j)~=0)
					fprintf('     ');
					fprintf(s.nms(j,:));
					fprintf('\n');
				end;
			end;
			fprintf('\n');
		end;
	end;
else
	for i=1:size(s.adj,1)				% for each variable
		fprintf(s.nms(i,:));
		fprintf('\n');
		for j=1:size(s.adj,2)
			if (s.adj(i,j)~=0)
				fprintf('     ');
				fprintf(s.nms(j,:));
				fprintf('\n');
			end;
		end;
		fprintf('\n');
	end;
end;
