function h=handles(S)
% HANDLES	h=handles(STR)
%			Creates a set of handles to the set of partitions
%			included in the structured matrix STR.
%			Handles are provided for levels (h.l01, h.l02 ...)
%			cycles (h.c01, h.c02 ...) and feedback loops.  The handles for
%			feedback loops are provided with 3 digits PLL (h.f101, h.f102 
%			...h.f201, h.f202 ...) where P is a cycle partition and LL the 
%			loop identifier. 
%		 	STR is expected to have the 6 components generated by the
%			structure.m	function.

if ~isa(S,'struct') error('Input matrix is not a structure array.'); end;

num= ['01'; '02'; '03'; '04'; '05'; ...
	  '06'; '07'; '08'; '09'; '10'; ...
	  '11'; '12'; '13'; '14'; '15'; ...
	  '16'; '17'; '18'; '19'; '20'; ...
	  '21'; '22'; '23'; '24'; '25'; ...
	  '26'; '27'; '28'; '29'; '30'; ...
	  '31'; '32'; '33'; '34'; '35'; ...
	  '36'; '37'; '38'; '49'; '40'; ...
	  '41'; '42'; '43'; '44'; '45'; ...
	  '46'; '47'; '48'; '49'; '50'; ...
	  '51'; '52'; '53'; '54'; '55'; ...
	  '56'; '57'; '58'; '59'; '60'; ...
	  '61'; '62'; '63'; '64'; '65'; ...
	  '66'; '67'; '68'; '69'; '70'; ...
	  '71'; '72'; '73'; '74'; '75'; ...
	  '76'; '77'; '78'; '79'; '80'; ...
	  '81'; '82'; '83'; '84'; '85'; ...
	  '86'; '87'; '88'; '89'; '90'; ...
	  '91'; '92'; '93'; '94'; '95'; ...
	  '96'; '97'; '98'; '99';];

h=[];
for i=1:size(S.lev,1)
	h=setfield(h,['l' num(i,:)],find(S.lev(i,:)));
end;

for i=1:size(S.cyc,1)
	h=setfield(h,['c' num(i,:)],find(S.cyc(i,:)));
end;

for i=1:size(S.fbl,3)
	nl=size(nonzeros(S.fbl(:,1,i)),1);					% number of loops -- loops are id by having the first col<>0
	for j=1:nl
		f=[];
		f(1,1:nnz(S.fbl(j,:,i)))=S.fbl(j,1:nnz(S.fbl(j,:,i)),i);
		h=setfield(h,['f' int2str(i) num(j,:)],f);
	end;
end;
