function p_loop(s,n,nif)
% P_LOOP 	p_loop(STR,LOOP)
%		 	Plots the scarcity graph of a structured matrix  
%		 	with impacts of the elements of a feebackloop (LOOP#)
%		 	highligted in red. 
%		 	STR is expected to have the 7 components generated by the
%			structure.m	function.
%			LOOP can either be a loop handle (see handle function), or
%			a direct reference to a loop according to the PLL format:
%			where P is a digit referring to the cycle partition and LL
%			are two digits identifying the loop within the partition.
%
%			p_loop(STR,LOOP,0)
%		 	The sparcity graph will be displayed in the
%			original order variables were intered, i.e., not sorted by
%			level partition.


if ~isa(s,'struct') error('Input matrix is not a structure array.'); end;

if size(n,2)==1	%if a direct call
	p=floor(n/100);
	l=rem(n,100);
	if p<1|p>size(s.fbl,3) error('Partition number exceeds matrix dimensions.'); end;
	if l<1|l>size(nonzeros(s.fbl(:,1,p)),1) error('Loop number exceeds matrix dimensions.'); end;
	d=s.fbl(l,:,p);
else			% a call through a handle
	d=n;
end;
	
ds=sparse(zeros(size(s.adj)));
first=d(1);
for i=1:size(d,2)					% for each element in the loop
	if d(i)>0						% if the end of the loop has not been reached
		if i+1<=size(d,2)			% en the end of the matrix has not been reached
			j=d(i+1);				% id next element
			if j>0					% if not last element in loop	
				ds(d(i),j)=s.adj(d(i),j);   	% take the value from the ADJ (should be 1)
			else					% if its the last element of loop
				ds(d(i),first)=s.adj(d(i),first);
			end
		else						% if its the last element of matrix
			ds(d(i),first)=s.adj(d(i),first);
		end
	end
end

if nargin==3&nif==0
	spy(s.adj)
	hold on
	spy(ds,'r')
	hold off
else
	spy(s.adj(s.idx.idx,s.idx.idx))
	hold on
	spy(ds(s.idx.idx,s.idx.idx),'r')
	hold off
	set(gca,'ytick',s.idx.tks,'xtick',s.idx.tks)
	set(gca,'xticklabel',s.idx.lbl,'yticklabel',s.idx.lbl)
%	set(gca,'grid','-.','xgrid','on','ygrid','on')
	grid on
end
